-- PhoenicianUA
-- Author: Sukritact
--=======================================================================================================================

print("loaded")
include("FLuaVector.lua")

function PositionCalculator(i1, i2)
	return HexToWorld(ToHexFromGrid(Vector2(i1, i2)))
end

-- isUsingEnginseerUCS
function isUsingEnginseerUCS()
	local UCS_ID1 = "b2eb6d1e-1fcb-4a0d-829c-51691aa3183a"
	local UCS_ID2 = "10c8e61b-b309-4b3e-8975-5e21b3214622"
	for _, mod in pairs(Modding.GetActivatedMods()) do
		if ((mod.ID == UCS_ID1) or (mod.ID == UCS_ID2)) then
			return true
		end
	end
	return false
end
local isUsingUCS = isUsingEnginseerUCS()

local eCivilizationPhoenicia = GameInfoTypes.CIVILIZATION_PHOENICIA
--=======================================================================================================================
-- Unit functions
--=======================================================================================================================
--------------------------------------------------------------------------------------
---------------------   Beit Melqart Diplomat Generation   ---------------------------
--------------------------------------------------------------------------------------
function MelqartDummy(iPlayer)
	local pPlayer = Players[iPlayer]
	
	if not (pPlayer and pPlayer:GetCivilizationType() == eCivilizationPhoenicia) then return end

	local pCapital = pPlayer:GetCapitalCity()
	
	if pCapital and pCapital:IsHasBuilding(GameInfoTypes.BUILDING_BEIT_MELQART) then
		pCapital:SetNumRealBuilding(GameInfoTypes.BUILDING_D_FOR_MELQART, pPlayer:GetNumInternationalTradeRoutesUsed())
	end
	
	if pPlayer:GetNumCities() > 1 then

		for pNewCity in pPlayer:Cities() do
		
			if not pNewCity:IsOriginalCapital() then
				
				local iShortestDistance = 99999
				local pNewCityOwner = nil
				for player in pairs(Players) do

					local MinorPlayer = Players[player]
					if (MinorPlayer and MinorPlayer:IsMinorCiv()) then 
					
						local iCSStartPlot = MinorPlayer:GetStartingPlot()
						if iCSStartPlot then
							
							local iDist = Map.PlotDistance(iCSStartPlot:GetX(), iCSStartPlot:GetY(), pNewCity:GetX(), pNewCity:GetY())
							if (iDist < iShortestDistance) then
								iShortestDistance = iDist
								pNewCityOwner = MinorPlayer
							end
						end
					end
				end
				pNewCityOwner:AcquireCity(pNewCity, false, false)
				pNewCityOwner:ChangeMinorCivFriendshipWithMajor(iPlayer, 60)
				pNewCityOwner:ChangeRestingPointChange(iPlayer, 60)
			end
		end
	end
end	
--	for player in pairs(Players) do
--		local MinorPlayer = Players[player]
--		if MinorPlayer and MinorPlayer:IsMinorCiv() then 
--			if MinorPlayer:HasPolicy(GameInfoTypes.POLICY_PHOENICIAN_METROPOLIS) then
--				if isUsingUCS then
--					MinorPlayer:ChangeMinorCivFriendshipWithMajor(iPlayer, math.max(0, (75 - MinorPlayer:GetMinorCivFriendshipWithMajor(iPlayer))))
--				else
--					MinorPlayer:ChangeMinorCivFriendshipWithMajor(iPlayer, math.max(0, (65 - MinorPlayer:GetMinorCivFriendshipWithMajor(iPlayer))))
--				end
--			end
--		end
--	end
--end
--------------------------------------------------------------------------------------
--------------------------   Metropolis CS Creation   --------------------------------
--------------------------------------------------------------------------------------
function OnFoundMetropolis(iPlayer)
	local pPlayer = Players[iPlayer]
	
	if not (pPlayer and pPlayer:GetCivilizationType() == eCivilizationPhoenicia) then return end

	if pPlayer:GetNumCities() > 1 then

		for pNewCity in pPlayer:Cities() do
			if not pNewCity:IsOriginalCapital() then
				local iX = pNewCity:GetX()
				local iY = pNewCity:GetY()
				local pPlot = Map.GetPlot(iX, iY)
				local pMinorName = pNewCity:GetName()
				Game.DoSpawnFreeCity(pNewCity, true)
				local pCity2 = pPlot:GetPlotCity()
				pCity2:SetName(pMinorName)
				local pNewCityOwner = Players[pPlot:GetOwner()]
				pNewCityOwner:GrantPolicy(GameInfoTypes.POLICY_PHOENICIAN_METROPOLIS, true)
				if isUsingUCS then
					pNewCityOwner:ChangeRestingPointChange(iPlayer, 75)
					pNewCityOwner:ChangeMinorCivFriendshipWithMajor(iPlayer, 75)
				else
					pNewCityOwner:ChangeRestingPointChange(iPlayer, 65)
					pNewCityOwner:ChangeMinorCivFriendshipWithMajor(iPlayer, 65)
				end
			end
		end
	end
end
--------------------------------------------------------------------------------------
--------------------   Phoenicia Cannot Attack CS Cities   ---------------------------
--------------------------------------------------------------------------------------
function MetropolisCSCaptureDisable(iAttackingPlayer, iAttackingUnit, attackerDamage, attackerFinalDamage, attackerMaxHP, iDefendingPlayer, iDefendingUnit, defenderDamage, defenderFinalDamage, defenderMaxHP, iInterceptingPlayer, iInterceptingUnit, interceptorDamage, iX, iY)

	local pAttacker = Players[iAttackingPlayer]
	local pDefender = Players[iDefendingPlayer]

	if not (pAttacker and pAttacker:GetCivilizationType() == eCivilizationPhoenicia) then return end
	
	if (pDefender and pDefender:IsMinorCiv()) then
		if Map.GetPlot(iX, iY):IsCity(pDefender) then
			return true
		end
	end
return false
end
--------------------------------------------------------------------------------------
-----------------------   Merchant Prince Trade Routes   -----------------------------
--------------------------------------------------------------------------------------
function MerchantPrinceTR(iPlayer, iUnit, iUnitType, iX, iY)
	local pPlayer = Players[iPlayer]

	if not (pPlayer and pPlayer:GetCivilizationType() == eCivilizationPhoenicia) then return end
	
	if iUnitType == GameInfoTypes.UNIT_PHOENICIAN_MERCHANT_PRINCE then
		local eDFMerchantPrince = GameInfoTypes.BUILDING_D_FOR_MERCHANT_PRINCE
		local pCapital = pPlayer:GetCapitalCity()
		pPlayer:GetCapitalCity():SetNumRealBuilding(eDFMerchantPrince, (pCapital:GetNumRealBuilding(eDFMerchantPrince) + 1))
	end
end
--------------------------------------------------------------------------------------
------------------------------   LUA activation   ------------------------------------
--------------------------------------------------------------------------------------
if Game.IsCivEverActive(eCivilizationPhoenicia) then
	GameEvents.PlayerDoTurn.Add(MelqartDummy)
	GameEvents.GreatPersonExpended.Add(MerchantPrinceTR)
	GameEvents.PlayerDoneTurn.Add(OnFoundMetropolis)
	GameEvents.MustAbortAttack.Add(MetropolisCSCaptureDisable)
end
--=======================================================================================================================
--=======================================================================================================================